﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

# <rtc-template block="description">
"""
 @file PoseRecognition.py
 @brief ModuleDescription
 @date $Date$


"""
# </rtc-template>

import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist

# Import other libraries
import math
# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
poserecognition_spec = ["implementation_id", "PoseRecognition", 
         "type_name",         "PoseRecognition", 
         "description",       "ModuleDescription", 
         "version",           "1.0.0", 
         "vendor",            "VenderName", 
         "category",          "Sample", 
         "activity_type",     "STATIC", 
         "max_instance",      "1", 
         "language",          "Python", 
         "lang_type",         "SCRIPT",
         ""]
# </rtc-template>

# <rtc-template block="component_description">
##
# @class PoseRecognition
# @brief ModuleDescription
# 
# 
# </rtc-template>
class PoseRecognition(OpenRTM_aist.DataFlowComponentBase):
	
    ##
    # @brief constructor
    # @param manager Maneger Object
    # 
    def __init__(self, manager):
        OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

        self._d_posePos = OpenRTM_aist.instantiateDataType(RTC.TimedDoubleSeq)
        """
        """
        self._posePosIn = OpenRTM_aist.InPort("posePos", self._d_posePos)
        self._d_posePattern = OpenRTM_aist.instantiateDataType(RTC.TimedString)
        """
        """
        self._posePatternOut = OpenRTM_aist.OutPort("posePattern", self._d_posePattern)


		


        # initialize of configuration-data.
        # <rtc-template block="init_conf_param">
		
        # </rtc-template>


		 
    ##
    #
    # The initialize action (on CREATED->ALIVE transition)
    # 
    # @return RTC::ReturnCode_t
    # 
    #
    def onInitialize(self):
        # Bind variables and configuration variable
		
        # Set InPort buffers
        self.addInPort("posePos",self._posePosIn)
		
        # Set OutPort buffers
        self.addOutPort("posePattern",self._posePatternOut)
		
        # Set service provider to Ports
		
        # Set service consumers to Ports
		
        # Set CORBA Service Ports
		
        return RTC.RTC_OK
	
    ###
    ## 
    ## The finalize action (on ALIVE->END transition)
    ## 
    ## @return RTC::ReturnCode_t
    #
    ## 
    #def onFinalize(self):
    #

    #    return RTC.RTC_OK
	
    ###
    ##
    ## The startup action when ExecutionContext startup
    ## 
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onStartup(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The shutdown action when ExecutionContext stop
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onShutdown(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The activated action (Active state entry action)
    ##
    ## @param ec_id target ExecutionContext Id
    ## 
    ## @return RTC::ReturnCode_t
    ##
    ##
    def onActivated(self, ec_id):
        self.now = time.time()
        self.count = 0
        self.patternDic = {'None':0, 'Init':0, 'rMiddle':0, 'lMiddle':0, 'rlMiddle':0, 'rUp':0, 'lUp':0, 'rlUp':0}
    
        return RTC.RTC_OK
	
    ###
    ##
    ## The deactivated action (Active state exit action)
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onDeactivated(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ##
    #
    # The execution action that is invoked periodically
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    def onExecute(self, ec_id):
        
        if self._posePosIn.isNew():
            self._d_posePos = self._posePosIn.read()

            #0:Nose 1:Neck 2:RShoulder 3:RElbow 4:RWrist 5:LShoulder 6:LElbow 7:LWrist
            #8:RHip 9:RKnee 10:RAnkle 11:LHip 12:LKnee 13:LAnkle 14:REye 15:LEye 16:REar 17:LEar 18:Background
            
            pattern = 'None'
            pattern = Pattern(self._d_posePos.data)
            self.patternDic[pattern] += 1

            if self.count > 50:
                Max_key = max(self.patternDic)
                Max_val = max(self.patternDic.values())

                OpenRTM_aist.setTimestamp(self._d_posePattern)
                if Max_val > 40:
                    self._d_posePattern.data = pattern
                else:
                    self._d_posePattern.data = 'None'
                self.count = 0

                print(self._d_posePattern)
                self._posePatternOut.write()
        
            self.count += 1
            
        
        return RTC.RTC_OK
	
    ###
    ##
    ## The aborting action when main logic error occurred.
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onAborting(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The error action in ERROR state
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onError(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The reset action that is invoked resetting
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onReset(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The state update action that is invoked after onExecute() action
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##

    ##
    #def onStateUpdate(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The action that is invoked when execution context's rate is changed
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onRateChanged(self, ec_id):
    #
    #    return RTC.RTC_OK
	
def Pattern(posePos):
    rShoulder = [posePos[2*2], posePos[2*2+1]]    
    lShoulder = [posePos[5*2], posePos[5*2+1]]
    rElbow = [posePos[3*2], posePos[3*2+1]]    
    lElbow = [posePos[6*2], posePos[6*2+1]]

    pattern = 'None'

    if rShoulder[1] > 0 and rElbow[1] > 0 and lShoulder[1] > 0 and lElbow[1] > 0:
        rAngle = math.atan( (rShoulder[1] - rElbow[1])/(abs(rShoulder[0] - rElbow[0]) + 0.001))
        lAngle = math.atan( (lShoulder[1] - lElbow[1])/(abs(lShoulder[0] - lElbow[0]) + 0.001))

        if rAngle < -0.2 and lAngle < -0.2:
            pattern = 'Init'

        if (rAngle >= -0.2 and rAngle < 0.2) and lAngle < -0.2:
            pattern = 'rMiddle'
        if rAngle < -0.2 and (lAngle >= -0.2 and lAngle < 0.2):
            pattern = 'lMiddle'
        if (rAngle >= -0.2 and rAngle < 0.2) and (lAngle >= -0.2 and lAngle < 0.2):
            pattern = 'rlMiddle'

        if rAngle >= 0.2 and lAngle < -0.2:
            pattern = 'rUp'
        if rAngle < -0.2 and lAngle >= 0.2:
            pattern = 'lUp'
        if rAngle >= 0.2 and lAngle >= 0.2:
            pattern = 'rlUp'

    return pattern


def PoseRecognitionInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=poserecognition_spec)
    manager.registerFactory(profile,
                            PoseRecognition,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    PoseRecognitionInit(manager)

    # create instance_name option for createComponent()
    instance_name = [i for i in sys.argv if "--instance_name=" in i]
    if instance_name:
        args = instance_name[0].replace("--", "?")
    else:
        args = ""
  
    # Create a component
    comp = manager.createComponent("PoseRecognition" + args)

def main():
    # remove --instance_name= option
    argv = [i for i in sys.argv if not "--instance_name=" in i]
    # Initialize manager
    mgr = OpenRTM_aist.Manager.init(sys.argv)
    mgr.setModuleInitProc(MyModuleInit)
    mgr.activateManager()
    mgr.runManager()

if __name__ == "__main__":
    main()

